/// <reference types="react" />
import { IPublicModelResource } from '@alilc/lowcode-types';
import { IResource } from '@alilc/lowcode-workspace';
import { resourceSymbol } from '../symbols';
export declare class Resource implements IPublicModelResource {
    readonly [resourceSymbol]: IResource;
    constructor(resource: IResource);
    get title(): string;
    get id(): string;
    get icon(): import("react").ReactElement<any, string | import("react").JSXElementConstructor<any>>;
    get options(): Record<string, any>;
    get name(): string;
    get config(): {
        [key: string]: any;
    };
    get type(): "webview" | "editor";
    get category(): string;
    get description(): string;
    get children(): Resource[];
    get viewName(): string;
}
